function HelpAssistant() {
	/* this is the creator function for your scene assistant object. It will be passed all the 
	   additional parameters (after the scene name) that were passed to pushScene. The reference
	   to the scene controller (this.controller) has not be established yet, so any initialization
	   that needs the scene controller should be done in the setup function below. */
}

HelpAssistant.prototype.setup = function() {
	/* this function is for setup tasks that have to happen when the scene is first created */
		
	/* use Mojo.View.render to render view templates and add them to the scene, if needed */
	
	/* setup widgets here */
	
	/* add event handlers to listen to events from widgets */
	this.listAttrs = {
		itemTemplate: 'templates/help-list-item',
		listTemplate: 'templates/listcontainer',
		swipeToDelete: false,
		reorderable: false
    };

	var mainItems = [
		{"id":"IBP","title":"Initial Battery %","content":"The actual battery percent reported by the battery at the time Battery Monitor is opened. This may vary from the percent reported to the device user interface found in the top bar and system menu. More details about why actual battery percent and reported percent are different can be found in a variety of places including the precentral forums."},
		{"id":"CBP","title":"Current Battery %","content":"The actual battery percent reported by the battery at the time of the last poll. Just like with the initial battery it too may vary from the percent reported to the device user interface found in the top bar and system menu."},
		{"id":"RT","title":"Runtime","content":"The total running time of Battery Monitor. It can be used to determine how long a battery lasts from fully charged to zero or whatever point is chosen for recharging. Recording the runtime for many charge cycles is useful for establishing the the average length of a normal days routine."},
		{"id":"DPH","title":"Drain per Hour %","content":"The average of the difference between initial and current battery percents and the runtime. It is somewhat flexible based on heavy usage and idle periods of time. And may be observed to increase or decrease accordingly especially during long periods of either."},
		{"id":"RL","title":"Remaining Life","content":"An estimated time in hours based on the current battery percent and the drain per hour percent. Like with the drain per hour percent heavy usage and long idle periods may impact the amount reported. Be cautious as the battery goes under 10% or even 5% because depending on usage and battery capacity while the battery is that low the remaining time may be overestimated. Especially if on a phone call or during another high consumption activity."},
		{"id":"BT","title":"Batt. Temperature","content":"The temperature in degrees Celsius reported by the battery temperature sensor. Most if not all battery manufactures advise that the battery temperature should not exceed 60C. Details can be found in a variety of places on the impact temperature has on the battery including the precentral forums. It is a good idea to keep an eye on the battery temperature if overclocking your device. Reminder, overclocking is an at your own risk activity."},
		{"id":"CT","title":"CPU Temperature","content":"The temperature in degrees Celsius reported by the CPU temperature sensor. A custom kernel with the service is required for it to be reported unless palm includes the service in the webOS kernel. Most CPUs are rated at a maximum temperature of 90C. Unless the CPU is overclocked it's temperature will not likely exceed 50C except during long heavy loads such as playing a 3D game. Battery charging, heavy data usage, and long phone calls may also increase the CPU temperature."},
		{"id":"mAv","title":"Current (mA)[Avg]","content":"The amount of mA at poll time. With it you can observe periods of usage and idle states. It may be observed to be between 1 and 8mA when the device is completely idle. And slightly spike at times where background activity such as a twitter client checks for new tweets. In brackets is the average mA for all polls. It can be used to get an over all picture total mA per hour used for a days routine or how much a specific thing uses if only running battery monitor for that one thing. mA average is more precise and rigid compaired to drain per hour %. It can be used as a secondary method of calculating remaining hours using the battery's capacity divided by the mA average."},
		{"id":"mAp","title":"mA as %","content":"Represents current (mA and mA average) in percent of the mAh capacity of the battery (set in the settings). In brackets is mA average as percent. It is an alternative representation of drain per hour percent but is best used in conjunction with it. At times one or the other may be a more acurate depending on usage amount."},
		{"id":"mV","title":"Voltage","content":"The mV reported at poll time. This is only useful if monitoring to be sure the battery is within the proper mV operating range. Nearly everyone will have no reason to need to do so, but it is included for those who may need to monitor it. Check the specifications for the proper mV operating range."}
	];
	this.controller.setupWidget('mainList', this.listAttrs, {listTitle: $L('Battery Monitor List'), items: mainItems});
	this.controller.listen('mainList', Mojo.Event.listTap, this.showHelpItem.bind(this));
	
	var settingsItems = [ //Graph Type will change to Default Graph --- This sets the graph type that shows by default when rotating into landscape mode to view the graph scene. See the graph type section below for details for each graph type.<!-- You can view other graph types in the graph scene by selecting the type from the menu list button.
		{"id":"GR","title":"Graphing","content":"If graphing is turned on Battery Monitor will temporarily store data for graphing. The graphs can be viewed by rotating the device into landscape mode. Rotating back to portrait mode will show the list. If graphing is turned off it will remain in portrait mode showing the list."},
		{"id":"GRT","title":"Graph Type","content":"This sets the graph type that shows when rotating into landscape mode to view the graph scene. See the graph type section below for details for each graph type."},
		{"id":"NT","title":"Notifications","content":"If this is set to on a notification will appear in the dashboard at the time of each poll with a brief overview of battery info. Current battery percent, drain per hour percent, and remaining life hours. It is recommended that notifications be turned off it the poll interval is set to one minute or less to avoid increased battery consumption."},
		{"id":"PI","title":"Poll Interval","content":"The interval at which Battery Monitor will check the services and update the list. The faster the interval the more accurate the over all picture of usage will be. If only the drain per hour percent at the end of a day is desired longer intervals will be fine. The more polls performed the more accurate all of the data in the list will be. The shorter the time Battery Monitor will be ran the shorter the poll should be set to. Examples: if only running for one or two hours 15 or 30 second interval should be used, for 24 hours or more 10 or 30 minute intervals are fine."},
		{"id":"CPT","title":"Capacity","content":"Change this to the capacity of the battery being used. If a battery capacity is missing please report the missing capacity in the official Battery Monitor thread on the precentral forums so that it may be added. This setting is used to calculate mA as % and if it doesn't match the your batteries capacity mA as % will be reported incorrectly."}
	];
	this.controller.setupWidget('settingsList', this.listAttrs, {listTitle: $L('Settings'), items: settingsItems});
	this.controller.listen('settingsList', Mojo.Event.listTap, this.showHelpItem.bind(this));

	var graphItems = [ //To change which graph is displayed tap the button labeled graph and pick the one desired from the list.
		{"id":"land","title":"How to View Graph Scene","content":"To view the graph scene make sure that graphing is turned on in the settings. While viewing the main scene rotating to landscape will show the graph scene. Rotating back to portrait will return view to the main scene."},
		{"id":"using","title":"How to Use Graph Scene","content":"The left and right arrow buttons at the top will move forward or backward between the pages of a graph. The X/X number between these arrows represents the current page out of the total pages for the graph."},
		{"id":"PRT","title":"Percent over Time Graph","content":"The amount of battery remaining over the total runtime.It is an over all picture of the how fast or slow the percentage declines from 100% to 0%. The down slope may steepen with heavy use and level off during idle time. You may find the other graphing types more useful."},
		{"id":"DPH","title":"Drain per Hour over Time Graph","content":"The drain per hour % list item graphed over time. During periods of use it will go up and drop back down during periods of idle time. Depending on usage patterns the up and down may not be very much or may be quite a significant shoot up or down."},
		{"id":"mAT","title":"mA over Time Graph","content":"Shows both mA and mA average (blue line) over time. This is probably the most useful graph as it shows the ups and downs of periods of use and idle time but also shows how that effects the over all average consumption. Periods of usage and idle time are much more distiguishable in this graph. Depending on usage mA average rise and fall may be subtle."}
	];
	this.controller.setupWidget('graphList', this.listAttrs, {listTitle: $L('Graph Details'), items: graphItems});
	this.controller.listen('graphList', Mojo.Event.listTap, this.showHelpItem.bind(this));	
};

HelpAssistant.prototype.showHelpItem = function(event) {
	var drawerID = event.item.id + '-drawer';
	this.controller.get(drawerID).mojo.toggleState();
};

HelpAssistant.prototype.activate = function(event) {
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */
};

HelpAssistant.prototype.deactivate = function(event) {
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */
};

HelpAssistant.prototype.cleanup = function(event) {
	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
};
