powerNotificationSession: null;      
queryBatteryStatusReq : null;  
tempVar : null;         
function SecondSceneAssistant() {
	/* this is the creator function for your scene assistant object. It will be passed all the 
	   additional parameters (after the scene name) that were passed to pushScene. The reference
	   to the scene controller (this.controller) has not be established yet, so any initialization
	   that needs the scene controller should be done in the setup function below. */
	// $("debug").innerHTML = Object.toJSON(model);
	this.mA = 0;
	this.mAt = 0;
	this.mV = 0;
	this.tempC = 0;
	this.cpuTempC = "---";
	this.capacity = 1150;
	this.interval = 60;
	this.points = 0;
	this.urlArray = [];
	this.urlString = "";
	// this.track = model.track;
	this.notificationEnabled = 'Off';
	this.graphEnabled = 'Off';
	this.count = 0;
	this.running = true;
	this.runningTotal = 0;
	this.batteryLevel = 0;
	this.expectedTime = 0;
	this.lastPayload = null;
	this.graphPoints = "";
	this.graphPointsB = "";
	this.startBatteryLevel = 0;
	this.startDate = new Date();
	//$("debug").innerHTML = Object.toJSON(model);	  
}

SecondSceneAssistant.prototype.setup = function() {
	/* this function is for setup tasks that have to happen when the scene is first created */
		
	/* use Mojo.View.render to render view templates and add them to the scene, if needed. */
	
	/* setup widgets here */
	
	/* add event handlers to listen to events from widgets */	
	this.listAttrs = {
		itemTemplate: 'templates/static-list-entry',
		listTemplate: 'templates/listcontainer',
		swipeToDelete: false,
		reorderable: false
    };
	this.listModel = {
		listTitle: $L('Battery Monitor'),
		items: [
			//{property:$L("Number of polls"), value:this.count},
			{property:$L("Interval (seconds)"), value:this.interval},
			{property:$L("Initial Battery %"), value:$L("")},
			{property:$L("Current Battery %"), value:$L("")},
			{property:$L("Runtime"), value:$L("")},			
			{property:$L("Drain per Hour %"), value:$L("")},
			{property:$L("Remaining Life (hrs)"), value:$L("")},
			{property:$L("Batt. Temperature (C)"), value:$L("")},
			{property:$L("CPU Temperature (C)"), value:$L("")},
			{property:$L("Current (mA)[Avg]"), value:$L("")},
			{property:$L("Current as percent"), value:$L("")},
			{property:$L("Voltage mV"), value:$L("")}
		]
	};
	this.controller.setupWidget("listInfoId", this.listAttrs, this.listModel); 
	/*this.controller.setupWidget("buttonShowInfoId",
        this.attributes = {
            },
        this.buttonModel = {
            label : "Detailed Battery Status",
            disabled: false
        });*/
	this.menuAttrs = {
		omitDefaultItems: true
	};
	this.menuModel = {
		visible: true,
		items: [
			{label: $L("Detailed Battery Info"), command: 'showDetailedInfo'},
			{label: $L("Settings"), command: 'settings'},
			{label: $L("Help"), command: 'help'}
        ]
    };
	this.controller.setupWidget(Mojo.Menu.appMenu, this.menuAttrs, this.menuModel);
	
	this.orientationListener = this.handleOrientation.bindAsEventListener(this);
	this.tempHandler = this.onTemp.bindAsEventListener(this);
	
	this.initOnServerStart("com.palm.power");
	//Mojo.Event.listen($("buttonShowInfoId"),Mojo.Event.tap, this.showPressed.bind(this));
			
};

SecondSceneAssistant.prototype.handleCommand = function(event) {
	if (event.type === Mojo.Event.command) {
		switch (event.command) {
			case "showDetailedInfo":
				Mojo.Controller.stageController.pushScene("show-info-scene", this.lastPayload);
				break;
			case "settings":
				//stop listening for landscape so graph scene isn't shown while settings scene is active
				this.controller.stopListening(this.controller.document, "orientationchange", this.orientationListener);
				this.controller.stageController.pushScene("settings");
				break;
			case "help":
				//stop listening for landscape so graph scene isn't shown while help scene is active
				this.controller.stopListening(this.controller.document, "orientationchange", this.orientationListener);
				this.controller.stageController.pushScene("help");
				break;	
		}
	}
};

SecondSceneAssistant.prototype.handleOrientation = function(event) {
	if (event.position == 4 || event.position == 5) {
		var orientation = "";
		if (event.position == 4) {
			orientation = "left";
		}
		else {
			orientation = "right";
		}
		this.controller.stopListening(this.controller.document, "orientationchange", this.orientationListener);
		Mojo.Controller.stageController.pushScene("graph", this.urlArray, orientation);
	}
};

SecondSceneAssistant.prototype.get_omap34xx_temp = function(callback)
{
	var request = new Mojo.Service.Request('palm://org.webosinternals.govnah',
	{
		method: 'get_omap34xx_temp',
		onSuccess: callback,
		onFailure: callback
	});
	return request;
};

SecondSceneAssistant.prototype.onTemp = function(payload){
	if (payload.returnValue) {
		this.cpuTempC = payload.value;
	}
	else {
		this.cpuTempC = "***";
	}
}
SecondSceneAssistant.prototype.showPressed = function(event) {
	Mojo.Controller.stageController.pushScene("show-info-scene", this.lastPayload);
};

SecondSceneAssistant.prototype.initP = function(payload){
	this.powerNotificationSession = new Mojo.Service.Request('palm://com.palm.bus/signal/', {
	method: 'addmatch',
	parameters: {"category":"/com/palm/power","method":"batteryStatus"},
	onSuccess : this.handlePowerNotifications.bind(this)});
	this.queryBatteryStatus();
};

SecondSceneAssistant.prototype.handlePowerNotifications = function(payload) {		
	// Is the battery level provided?
	var dateObj = new Date();
	var currentTime = dateObj.getTime();
	if(currentTime >= this.expectedTime)
	{
		if (payload.percent != undefined) {
			this.count = this.count + 1;
			if(this.batteryLevel == 0)
			{
				this.batteryLevel = payload.percent;
				this.startBatteryLevel = payload.percent;
			}
			//$("debug").innerHTML = Object.toJSON(payload);//this.batteryLevel +" "+ this.count;
			this.mA = payload.current_mA;
			var mApcnt = this.mA / this.capacity;
			mApcnt = mApcnt * -100;
			mApcnt = mApcnt.toFixed(2);
			this.mAt += this.mA;
			var mAavg = this.mAt / this.count;
			mAavg = Math.round(mAavg);
			var mAavgPcnt = mAavg / this.capacity;
			mAavgPcnt = mAavgPcnt * -100;
			mAavgPcnt = mAavgPcnt.toFixed(2);
			this.mV = payload.voltage_mV;
			this.tempC = payload.temperature_C;
			this.get_omap34xx_temp(this.tempHandler);
			this.batteryLevel = payload.percent;
			var difference = this.startBatteryLevel - this.batteryLevel;			
			this.runningTotal = this.runningTotal + difference;
			var average = 0;
			var runTimeSeconds = currentTime - this.startDate.getTime();
			var totalSeconds = runTimeSeconds/1000;
			var runTime = new Date();
			runTime.setTime(runTimeSeconds);
			var day = runTime.getUTCDate(); //sets day to 1
			day = day - 1; //adjusts to allow for first 24 hours to pass for day to be incremented
			var hour = runTime.getUTCHours();
			var minute = runTime.getMinutes();
			var second = runTime.getSeconds();
			var runTimeString = "";
			if(day > 0)
			{
				runTimeString = runTimeString + day + "d ";
			}
			if(hour > 0)
			{
				runTimeString = runTimeString + hour + "h ";		
			}
			if(minute > 0)
			{
				runTimeString = runTimeString + minute + "m ";
			}			
			runTimeString = runTimeString + second + "s";	
			//if this is not the first polling
			if(this.count > 1){
				average = (difference / (totalSeconds/3600));
			} 
			//Save the Battery Percentage

			var lifeRemain = 0;
			if(average > 0) lifeRemain = this.batteryLevel/average;
			average = average.toFixed(2);
			lifeRemain = lifeRemain.toFixed(2);
			$("listInfoId").mojo.noticeUpdatedItems(0,
				[ 
					//{property:$L("Number of polls"), value:this.count},
		 			{property:$L("Interval (seconds)"), value:this.interval},
					{property:$L("Initial Battery %"), value:this.startBatteryLevel},
		            {property:$L("Current Battery %"), value:this.batteryLevel},
					{property:$L("Runtime"), value:runTimeString},		           		
					{property:$L("Drain per Hour %"), value: average},
					{property:$L("Remaining Life (hours)"), value:lifeRemain},
					{property:$L("Batt. Temperature (C)"), value:this.tempC},
					{property:$L("CPU Temperature (C)"), value:this.cpuTempC},
					{property:$L("Current (mA)[Avg]"), value:this.mA + " [" + mAavg + "]"},
					{property:$L("mA as % [Avg]"), value:mApcnt + " [" + mAavgPcnt + "]"},
					{property:$L("Voltage (mV)"), value:this.mV}
				]);
			
			//graph generation
			if (this.graphEnabled == 'On') {
				var minutes = dateObj.getMinutes();
				if(minutes < 10)
				{
					minutes = "0" + minutes;
				}
				var currentTime = dateObj.getHours() + ":" + minutes;

				if (this.count == 1) {
					this.beginTime = currentTime;
					this.urlArray.push("");
					this.element = 0;
				}

				if (this.points == 100) {
					this.beginTime = currentTime;
					this.urlArray.push("");
					this.element++;
					this.points = 0;
				}

				switch(this.graphType){
					case "PRT":
						if (this.count == 1) {
							this.graphPoints = this.batteryLevel;
						}
						else {
							this.graphPoints = this.graphPoints + "," + this.batteryLevel;
						}//end if..else
						
						this.points++;
						this.urlString = "http://chart.apis.google.com/chart?chs=480x320&chd=t:" + this.graphPoints + "&cht=lc&chxt=x,y&chxl=0:|" + this.beginTime + "|" + currentTime + "&chf=bg,s,65432100&chxs=0,FF9933|1,FF9933";
						break;
					case "DPH":
						if (this.count == 1 && average != 0) {
							this.yAxisTop = average;
							step = average / 4;
						}
						else {
							this.yAxisTop = 1;
							step = 1;
						}//end if..else
						if (this.points == 0) {
							this.graphPoints = average;
						}
						else {
							this.graphPoints = this.graphPoints + "," + average;
							if (average > this.yAxisTop) {
								this.yAxisTop = average;
								step = average / 4;
							}
						}//end if..else
						
						if (average != 0) {
							this.points++;
						}
						this.urlString = "http://chart.apis.google.com/chart?chs=480x320&chd=t:" + this.graphPoints + "&cht=lc&chds=0," + this.yAxisTop + "&chxr=1,0," + this.yAxisTop + "," + step + "&chxt=x,y&chxl=0:|" + this.beginTime + "|" + currentTime + "&chf=bg,s,65432100&chxs=0,FF9933|1,FF9933";
						break;
					case "mAT":
						if (this.count == 1) {
							this.yAxisTop = Math.abs(this.mA);
							step = Math.round(Math.abs(this.mA) / 10);
							if (step < 1 && Math.abs(this.mA) <= 10) {
								step = 1;
							}
						}
						if (this.points == 0) {
							this.graphPoints = Math.abs(this.mA);
							this.graphPointsB = Math.abs(mAavg);
						}
						else {
							this.graphPoints = this.graphPoints + "," + Math.abs(this.mA);
							this.graphPointsB = this.graphPointsB + "," + Math.abs(mAavg);
							if (Math.abs(this.mA) > this.yAxisTop) {
								this.yAxisTop = Math.abs(this.mA);
								step = Math.round(Math.abs(this.mA) / 10);
								if (step < 1 && Math.abs(this.mA) <= 10) {
									step = 1;
								}
							}
						}//end if..else
						
						this.points++;
						this.urlString = "http://chart.apis.google.com/chart?chs=480x320&chd=t:" + this.graphPoints + "|" + this.graphPointsB + "&cht=lc&chds=0," + this.yAxisTop + "&chxr=1,0," + this.yAxisTop + "," + step + "&chxt=x,y&chxl=0:|" + this.beginTime + "|" + currentTime+ "&chf=bg,s,65432100&chxs=0,FF9933|1,FF9933&chco=FF9933,1f75bf";
				}//end switch
				
				this.urlArray[this.element] = this.urlString;
			}//end graph generation	

			if(this.notificationEnabled == 'On'){
				//to-do: put in notifications
				var msg = {messageText: "CB: "+this.batteryLevel+"% - DPH: "+average+"% - RL: "+lifeRemain+"hrs"}	
    			//Mojo.Controller.getAppController().sendToNotificationChain(msg);
				Mojo.Controller.getAppController().showBanner(msg, "","Information");

			}
			
			if (this.running) {
				this.lastPayload = payload;
				currentTime = dateObj.getTime();
				this.expectedTime = currentTime + this.interval * 1000;
				this.queryBatteryStatus.delay(this.interval);
			}
		}//end if payload
	}//end if currentTime
};

SecondSceneAssistant.prototype.queryBatteryStatus = function() {
	this.queryBatteryStatusReq = new Mojo.Service.Request('palm://com.palm.power/com/palm/power/', {
		method: 'batteryStatusQuery'});
		
};

SecondSceneAssistant.prototype.initOnServerStart = function(serviceName) {	
		
	this.tempVar = new Mojo.Service.Request('palm://com.palm.bus/signal/', {
		method: 'registerServerStatus',
		parameters: {'serviceName':serviceName},
		onSuccess: this.initP.bind(this)
	});
};

SecondSceneAssistant.prototype.handleServerStatus = function(payload){
		this.initP();	 
};

SecondSceneAssistant.prototype.activate = function(event) {
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */
	this.cookie = new Mojo.Model.Cookie("BatMonCookie");
	var cookie = this.cookie.get();
	if(!cookie) {
		this.cookie.put({
			PollInterval: 60,
			Notifications: "Off",
			Graphing: "Off",
			GraphType: "PRT",
			Capacity: 1150
		});
	}
	else {
		this.interval = cookie.PollInterval;
		this.notificationEnabled = cookie.Notifications;
		this.graphEnabled = cookie.Graphing;
		this.graphType = cookie.GraphType;
		this.capacity = cookie.Capacity;
	} //end if..else
	
	if (this.graphEnabled == "On") {
		this.controller.stageController.setWindowOrientation("up");
		this.controller.listen(this.controller.document, "orientationchange", this.orientationListener);
	}
	else {
		this.controller.stopListening(this.controller.document, "orientationchange", this.orientationListener);
	}
	
	$("listInfoId").mojo.noticeUpdatedItems(0,
	[ 
		//{property:$L("Number of polls"), value:this.count},
		{property:$L("Interval (seconds)"), value:this.interval},
	]);

};


SecondSceneAssistant.prototype.deactivate = function(event) {
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */

};

SecondSceneAssistant.prototype.cleanup = function(event) {
	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
	  this.running = false;
	  this.powerNotificationSession.cancel();
	  this.queryBatteryStatusReq.cancel();
	  this.tempVar.cancel();
	  this.controller.stopListening(this.controller.document, "orientationchange", this.orientationListener);
};
