function ShowInfoSceneAssistant(payload) {
	/* this is the creator function for your scene assistant object. It will be passed all the 
	   additional parameters (after the scene name) that were passed to pushScene. The reference
	   to the scene controller (this.controller) has not be established yet, so any initialization
	   that needs the scene controller should be done in the setup function below. */
	  this.payload = payload;
}

ShowInfoSceneAssistant.prototype.setup = function() {
	/* this function is for setup tasks that have to happen when the scene is first created */
		
	/* use Mojo.View.render to render view templates and add them to the scene, if needed. */
	
	/* setup widgets here */
	    this.controller.setupWidget("listInfoId2",
         this.attributes = {
             itemTemplate: 'templates/static-list-entry',
			 listTemplate:'templates/listcontainer',
             swipeToDelete: false,
             reorderable: false
         },
         this.model = {
             listTitle: $L('Detailed Battery Status'),
             items : [
                {property:$L("Actual %"), value:this.payload.percent},
				{property:$L("Reported UI %"), value:this.payload.percent_ui},
				{property:$L("Temperature (C)"), value:this.payload.temperature_C},
				{property:$L("Current mA"), value:this.payload.current_mA},
				{property:$L("Voltage mV"), value:this.payload.voltage_mV},
				//{property:$L("Capacity mAh"), value:this.payload.capacity_mAh},
             ]
         });

	/* add event handlers to listen to events from widgets */
}

ShowInfoSceneAssistant.prototype.activate = function(event) {
	/* put in event handlers here that should only be in effect when this scene is active. For
	   example, key handlers that are observing the document */
}


ShowInfoSceneAssistant.prototype.deactivate = function(event) {
	/* remove any event handlers you added in activate and do any other cleanup that should happen before
	   this scene is popped or another scene is pushed on top */
}

ShowInfoSceneAssistant.prototype.cleanup = function(event) {
	/* this function should do any cleanup needed before the scene is destroyed as 
	   a result of being popped off the scene stack */
}
